%% ANALÝZA SIGNÁLŮ:
% Skript pro analýzu měřených signálů

% {
clear all, close all, clc
signaly = load('mereniNemocnice.mat');
nazvySignalu = fieldnames(signaly);
%}

%{
for i = 1:length(nazvySignalu)  % for cyklus pro analyzování kompletního
                                % setu signálů a ukládání souborů grafů
%}
vyber = nazvySignalu{1,:};     % pro analýzu celého setu signálů nutno změnit index na 'i'
prubeh = signaly.(vyber);


%% Úprava raw dat z měřícího přípravku:
[signal,x,y,z,cas] = upravSignal(prubeh,0);     % přepočet raw signálů

%{
nazev = char(strcat(nazvySignalu(i,:),'_prubehXYZ','.png'));
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP\Grafy\prubehyXYZ'
saveas(gcf,nazev);
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP'
close all
%}

%% Vektor zrychlení v prostoru:
a = vyslednyVektor(x,y,z,cas,0);      % výpočet velikosti výsledného zrychlení ovladače

%{
nazev = char(strcat(nazvySignalu(i,:),'_prubehA','.png'));
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP\Grafy\prubehA'
saveas(gcf,nazev);
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP'
close all
%}

%% Interpolace pro možnost FFT (převzorkování):
[aIpl,xIpl,yIpl,zIpl,casNovy] = interpolace(a,x,y,z,cas,'linear',1);   % převzorkování interpolací

%{
nazev1 = char(strcat(nazvySignalu(i,:),'_srovnaniX','.png'));
nazev2 = char(strcat(nazvySignalu(i,:),'_srovIplMet','.png'));
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP\Plots\interpolace'
saveas(1,nazev1);
saveas(2,nazev2);
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP'
close all
%}

%% Frekvenční analýza pomocí Fourierovy transformace:
[spektrum,fVz] = spektrumVypocet([xIpl;yIpl;zIpl],casNovy,1,'hamming');
%[spektrum,fVz] = spektrumVypocet(aIpl,casNovy,1,'hamming');

%{
nazev = char(strcat(nazvySignalu(i,:),'_spektrumXYZ','.png'));
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP\Grafy\spektrumXYZ'
saveas(gcf,nazev);
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP'
close all
%}

%% Časově-frekvenční analýza - spektrogram:
spektrogramy = speGram(aIpl,xIpl,yIpl,zIpl,fVz,0.05,0.025);

%{
nazev = char(strcat(nazvySignalu(i,:),'_spekGramAXYZ','.png'));
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP\Grafy\spektrogramyAXYZ'
saveas(gcf,nazev);
cd 'C:\Users\ferdi\Documents\DOKUMENTY\Škola\VUT\6. semestr\ABCE\MatLab\BP'
close all
%}

%% Medián a Průměr:
medMat = [median(a),median(x),median(y),median(z)];
pruMat = [mean(a),mean(x),mean(y),mean(z)];


%{
end
%}